//    File:  BinarySearch.java
   
    public class BinarySearch {

        BinarySearch(int[] nArray) {
            for (int i = 0; i < nArray.length; i++)
                nArray[i] = i;
            for (int i = -1; i <= nArray.length; i++)
                System.out.println(i + " is at " + binarySearch(i, nArray));
        }

        public static void main(String[] args) {
            System.out.println("Demonstrate Binary Search");
            System.out.println();
            new BinarySearch(new int[10]);
            System.out.println();
            System.out.println("Fin!");
        }
            
        //--------------------------------------------
        //    Binary Search Algorithm:
        //        Divide the remaining table in half
        //        Check the midpoint; if found, DONE
        //        If not found, consider the first half 
        //            or second half, depending...
        //        and do Binary Search on it
        //        If the partition size goes to ONE, the
        //            item is NOT present in the table
        //--------------------------------------------
        int binarySearch (final int nKey, final int nArray []) {
            int  nLoc = -1, nLow = 0, nHigh = nArray.length-1;
        
            while (nHigh >= nLow) {
                int m = (nLow + nHigh) / 2;
                if (nKey == nArray [m])
                    {  nLoc = m;  break;  }
                if (nKey < nArray [m])
                    nHigh = m - 1;
                else
                    nLow = m + 1;
            }
            return nLoc;
        }

}

/* ----- Execution Output -----

Demonstrate Binary Search

-1 is at -1
0 is at 0
1 is at 1
2 is at 2
3 is at 3
4 is at 4
5 is at 5
6 is at 6
7 is at 7
8 is at 8
9 is at 9
10 is at -1

Fin!

----- End Output ----- */
